/*A small applet that uses Bresenham's algorithm to draw thick lines*/

import java.applet.Applet;
import java.awt.*;
import java.util.StringTokenizer ;
import java.awt.image.*;

public class LineDraw extends Applet implements Runnable {
 
 Thread myThread ;
 
 Image 		memImg ;
 
 int		mouse_x,mouse_y;
 int		old_x,old_y;
 int		brushWidth = 2;
 boolean	Draw = false;
 

 /* init is called automatically by the run-time system */
 public void init() {
   resize(400,300);
   
   brushWidth = Integer.parseInt(getParameter("Width"));
   
   
 }
 

 // the only function of start is to start a thread
 // and create the memory Image
 public void start() {
   if( myThread == null ) {
     myThread = new Thread( this ) ;
     myThread.start();
   }
   
   if( memImg == null ) {
     memImg = createImage( size().width, size().height );
   }
 }


 // myThread will call this run() method
 public void run() {
   while( myThread != null ) {
    try {
    	
     myThread.sleep( 50 );  
       repaint();
      
       
    } catch(InterruptedException e ) {}
   }
   
 }
   

 public void stop() {
   if( myThread != null ) {
     myThread.stop();
     myThread = null ;
  	}
 }


public void update( Graphics g) {
   paint( g ) ;
  
}

 
 
public boolean mouseUp(java.awt.Event evt, int x, int y) {
	Draw = false;
	return true;
    }
    
        
public boolean mouseDown(java.awt.Event evt, int x, int y) {
	mouse_x = x;
	mouse_y = y;
	Draw = true;
 	return true;	
}
 
 // the line drawing routine...	
 public void	ThickLine(Graphics g,Color c,int width,int sx,int sy,int ex,int ey)
 {
 	int			dx,dy;
 	int			xDirection,yDirection;
 	int			error_term;
 	
	g.setColor(c);
	
	dx = sx - ex;
 	if(dx < 0) dx = -dx;
 	dy = sy - ey;
 	if(dy < 0) dy = -dy;
 		
 	if(ex-sx < 0) xDirection = -1;
 	else if(ex-sx > 0) xDirection = 1;
 	else xDirection = 0;
 	if(ey-sy < 0) yDirection = -1;
 	else if(ey-sy > 0) yDirection = 1;
 	else yDirection = 0;
 		
 	error_term = 0;
 	if(dx > dy)
 	{
 		for(int	i=0;i<=dx;i++){
 			g.fillOval(sx-(width/2),sy-(width/2),width,width);
 			sx += xDirection;
 			error_term += dy;
 			if(error_term>dx){
 				error_term -= dx;
 				sy += yDirection;
 					}
 				}
 			}
 		else{
 			for(int	i=0;i<=dy;i++){
 				g.fillOval(sx-(width/2),sy-(width/2),width,width);
 				sy += yDirection;
 				error_term += dx;
 				if(error_term > dy){
 					error_term -= dy;
 					sx += xDirection;
 					}
 				}
 			}
 			
 }

 
 // Compose the entire image in memory first, then paint to screen 
 public void paint( Graphics g) {
 	
 	Graphics memg = memImg.getGraphics();
 	
 	Color		c;
 	
 	
 	c = new Color(255,0,0); // red
 	
 	
 	if(Draw == true){
 		ThickLine(memg,c,brushWidth,old_x,old_y,mouse_x,mouse_y);
 		old_x = mouse_x;
 		old_y = mouse_y;
 		}
 	
 	// only now do wedraw to the screen
    g.drawImage( memImg, 0,0, this );
    	
 }
 

 	
 	/**
     * Applet info.
     */
    public String getAppletInfo() {
	return "Line draw, coded by Rob Amos";
    }
} // end class Bouncer
